Package org.eclipse.jdt.core.refactoring

# Interface IJavaRefactorings

public interface IJavaRefactorings
Interface for refactoring ids offered by the JDT tooling.

This interface provides refactoring ids for refactorings offered by the JDT tooling. Refactoring instances corresponding to such an id may be instantiated by the refactoring framework using `RefactoringCore.getRefactoringContribution(String)`. The resulting refactoring instance may be executed on the workspace with a `PerformRefactoringOperation`.

Clients may obtain customizable refactoring descriptors for a certain refactoring by calling `RefactoringCore.getRefactoringContribution(String)` with the appropriate refactoring id and then calling `RefactoringContribution.createDescriptor()` to obtain a customizable refactoring descriptor. The concrete subtype of refactoring descriptors is dependent from the `id` argument.

Note: this interface is not intended to be implemented by clients.

Since:
  1.1
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`CHANGE_METHOD_SIGNATURE`
Refactoring id of the 'Change Method Signature' refactoring (value: `org.eclipse.jdt.ui.change.method.signature`).
`static final String`
`CONVERT_ANONYMOUS`
Refactoring id of the 'Convert Anonymous To Nested' refactoring (value: `org.eclipse.jdt.ui.convert.anonymous`).
`static final String`
`CONVERT_LOCAL_VARIABLE`
Refactoring id of the 'Convert Local Variable to Field' refactoring (value: `org.eclipse.jdt.ui.promote.temp`).
`static final String`
`CONVERT_MEMBER_TYPE`
Refactoring id of the 'Convert Member Type to Top Level' refactoring (value: `org.eclipse.jdt.ui.move.inner`).
`static final String`
`CONVERT_TO_RECORD`
Refactoring id of the 'Convert type to record' refactoring (value: `org.eclipse.jdt.ui.convert.to.record`).
`static final String`
`COPY`
Refactoring id of the 'Copy' refactoring (value: `org.eclipse.jdt.ui.copy`).
`static final String`
`DELETE`
Refactoring id of the 'Delete' refactoring (value: `org.eclipse.jdt.ui.delete`).
`static final String`
`ENCAPSULATE_FIELD`
Refactoring id of the 'Encapsulate Field' refactoring (value: `org.eclipse.jdt.ui.self.encapsulate`).
`static final String`
`EXTRACT_CLASS`
Refactoring id of the 'Extract Class' refactoring (value: `"org.eclipse.jdt.ui.extract.class`).
`static final String`
`EXTRACT_CONSTANT`
Refactoring id of the 'Extract Constant' refactoring (value: `org.eclipse.jdt.ui.extract.constant`).
`static final String`
`EXTRACT_INTERFACE`
Refactoring id of the 'Extract Interface' refactoring (value: `org.eclipse.jdt.ui.extract.interface`).
`static final String`
`EXTRACT_LOCAL_VARIABLE`
Refactoring id of the 'Extract Local Variable' refactoring (value: `org.eclipse.jdt.ui.extract.temp`).
`static final String`
`EXTRACT_METHOD`
Refactoring id of the 'Extract Method' refactoring (value: `org.eclipse.jdt.ui.extract.method`).
`static final String`
`EXTRACT_SUPERCLASS`
Refactoring id of the 'Extract Superclass' refactoring (value: `org.eclipse.jdt.ui.extract.superclass`).
`static final String`
`GENERALIZE_TYPE`
Refactoring id of the 'Generalize Declared Type' refactoring (value: `org.eclipse.jdt.ui.change.type`).
`static final String`
`INFER_TYPE_ARGUMENTS`
Refactoring id of the 'Infer Type Arguments' refactoring (value: `org.eclipse.jdt.ui.infer.typearguments`).
`static final String`
`INLINE_CONSTANT`
Refactoring id of the 'Inline Constant' refactoring (value: `org.eclipse.jdt.ui.inline.constant`).
`static final String`
`INLINE_LOCAL_VARIABLE`
Refactoring id of the 'Inline Local Variable' refactoring (value: `org.eclipse.jdt.ui.inline.temp`).
`static final String`
`INLINE_METHOD`
Refactoring id of the 'Inline Method' refactoring (value: `org.eclipse.jdt.ui.inline.method`).
`static final String`
`INTRODUCE_FACTORY`
Refactoring id of the 'Introduce Factory' refactoring (value: `org.eclipse.jdt.ui.introduce.factory`).
`static final String`
`INTRODUCE_INDIRECTION`
Refactoring id of the 'Introduce Indirection' refactoring (value: `org.eclipse.jdt.ui.introduce.indirection`).
`static final String`
`INTRODUCE_PARAMETER`
Refactoring id of the 'Introduce Parameter' refactoring (value: `org.eclipse.jdt.ui.introduce.parameter`).
`static final String`
`INTRODUCE_PARAMETER_OBJECT`
Refactoring id of the 'Introduce Parameter Object' refactoring (value: `org.eclipse.jdt.ui.introduce.parameter.object`).
`static final String`
`MOVE`
Refactoring id of the 'Move' refactoring (value: `org.eclipse.jdt.ui.move`).
`static final String`
`MOVE_METHOD`
Refactoring id of the 'Move Method' refactoring (value: `org.eclipse.jdt.ui.move.method`).
`static final String`
`MOVE_STATIC_MEMBERS`
Refactoring id of the 'Move Static Members' refactoring (value: `org.eclipse.jdt.ui.move.static`).
`static final String`
`PULL_UP`
Refactoring id of the 'Pull Up' refactoring (value: `org.eclipse.jdt.ui.pull.up`).
`static final String`
`PUSH_DOWN`
Refactoring id of the 'Push Down' refactoring (value: `org.eclipse.jdt.ui.push.down`).
`static final String`
`RENAME_COMPILATION_UNIT`
Refactoring id of the 'Rename Compilation Unit' refactoring (value: `org.eclipse.jdt.ui.rename.compilationunit`).
`static final String`
`RENAME_ENUM_CONSTANT`
Refactoring id of the 'Rename Enum Constant' refactoring (value: `org.eclipse.jdt.ui.rename.enum.constant`).
`static final String`
`RENAME_FIELD`
Refactoring id of the 'Rename Field' refactoring (value: `org.eclipse.jdt.ui.rename.field`).
`static final String`
`RENAME_JAVA_PROJECT`
Refactoring id of the 'Rename Java Project' refactoring (value: `org.eclipse.jdt.ui.rename.java.project`).
`static final String`
`RENAME_LOCAL_VARIABLE`
Refactoring id of the 'Rename Local Variable' refactoring (value: `org.eclipse.jdt.ui.rename.local.variable`).
`static final String`
`RENAME_METHOD`
Refactoring id of the 'Rename Method' refactoring (value: `org.eclipse.jdt.ui.rename.method`).
`static final String`
`RENAME_MODULE`
Refactoring id of the 'Rename Module' refactoring (value: `org.eclipse.jdt.ui.rename.module`).
`static final String`
`RENAME_PACKAGE`
Refactoring id of the 'Rename Package' refactoring (value: `org.eclipse.jdt.ui.rename.package`).
`static final String`
`RENAME_RESOURCE`
Deprecated.
Since 1.2.
`static final String`
`RENAME_SOURCE_FOLDER`
Refactoring id of the 'Rename Source Folder' refactoring (value: `org.eclipse.jdt.ui.rename.source.folder`).
`static final String`
`RENAME_TYPE`
Refactoring id of the 'Rename Type' refactoring (value: `org.eclipse.jdt.ui.rename.type`).
`static final String`
`RENAME_TYPE_PARAMETER`
Refactoring id of the 'Rename Type Parameter' refactoring (value: `org.eclipse.jdt.ui.rename.type.parameter`).
`static final String`
`USE_SUPER_TYPE`
Refactoring id of the 'Use Supertype Where Possible' refactoring (value: `org.eclipse.jdt.ui.use.supertype`).

## Field Details

### CHANGE_METHOD_SIGNATURE

static final String CHANGE_METHOD_SIGNATURE
Refactoring id of the 'Change Method Signature' refactoring (value: `org.eclipse.jdt.ui.change.method.signature`).

Clients may safely cast the obtained refactoring descriptor to `ChangeMethodSignatureDescriptor`.

See Also:
  - Constant Field Values

### CONVERT_ANONYMOUS

static final String CONVERT_ANONYMOUS
Refactoring id of the 'Convert Anonymous To Nested' refactoring (value: `org.eclipse.jdt.ui.convert.anonymous`).

Clients may safely cast the obtained refactoring descriptor to `ConvertAnonymousDescriptor`.

See Also:
  - Constant Field Values

### CONVERT_LOCAL_VARIABLE

static final String CONVERT_LOCAL_VARIABLE
Refactoring id of the 'Convert Local Variable to Field' refactoring (value: `org.eclipse.jdt.ui.promote.temp`).

Clients may safely cast the obtained refactoring descriptor to `ConvertLocalVariableDescriptor`.

See Also:
  - Constant Field Values

### CONVERT_TO_RECORD

static final String CONVERT_TO_RECORD
Refactoring id of the 'Convert type to record' refactoring (value: `org.eclipse.jdt.ui.convert.to.record`).

Clients may safely cast the obtained refactoring descriptor to `ConvertLocalVariableDescriptor`.

Since:
  1.24
See Also:
  - Constant Field Values

### CONVERT_MEMBER_TYPE

static final String CONVERT_MEMBER_TYPE
Refactoring id of the 'Convert Member Type to Top Level' refactoring (value: `org.eclipse.jdt.ui.move.inner`).

Clients may safely cast the obtained refactoring descriptor to `ConvertMemberTypeDescriptor`.

See Also:
  - Constant Field Values

### COPY

static final String COPY
Refactoring id of the 'Copy' refactoring (value: `org.eclipse.jdt.ui.copy`).

Clients may safely cast the obtained refactoring descriptor to `CopyDescriptor`.

See Also:
  - Constant Field Values

### DELETE

static final String DELETE
Refactoring id of the 'Delete' refactoring (value: `org.eclipse.jdt.ui.delete`).

Clients may safely cast the obtained refactoring descriptor to `DeleteDescriptor`.

See Also:
  - Constant Field Values

### ENCAPSULATE_FIELD

static final String ENCAPSULATE_FIELD
Refactoring id of the 'Encapsulate Field' refactoring (value: `org.eclipse.jdt.ui.self.encapsulate`).

Clients may safely cast the obtained refactoring descriptor to `EncapsulateFieldDescriptor`.

See Also:
  - Constant Field Values

### EXTRACT_CLASS

static final String EXTRACT_CLASS
Refactoring id of the 'Extract Class' refactoring (value: `"org.eclipse.jdt.ui.extract.class`).

Clients may safely cast the obtained refactoring descriptor to `ExtractClassDescriptor`.

Since:
  1.2
See Also:
  - Constant Field Values

### EXTRACT_CONSTANT

static final String EXTRACT_CONSTANT
Refactoring id of the 'Extract Constant' refactoring (value: `org.eclipse.jdt.ui.extract.constant`).

Clients may safely cast the obtained refactoring descriptor to `ExtractConstantDescriptor`.

See Also:
  - Constant Field Values

### EXTRACT_INTERFACE

static final String EXTRACT_INTERFACE
Refactoring id of the 'Extract Interface' refactoring (value: `org.eclipse.jdt.ui.extract.interface`).

Clients may safely cast the obtained refactoring descriptor to `ExtractInterfaceDescriptor`.

See Also:
  - Constant Field Values

### EXTRACT_LOCAL_VARIABLE

static final String EXTRACT_LOCAL_VARIABLE
Refactoring id of the 'Extract Local Variable' refactoring (value: `org.eclipse.jdt.ui.extract.temp`).

Clients may safely cast the obtained refactoring descriptor to `ExtractLocalDescriptor`.

See Also:
  - Constant Field Values

### EXTRACT_METHOD

static final String EXTRACT_METHOD
Refactoring id of the 'Extract Method' refactoring (value: `org.eclipse.jdt.ui.extract.method`).

Clients may safely cast the obtained refactoring descriptor to `ExtractMethodDescriptor`.

See Also:
  - Constant Field Values

### EXTRACT_SUPERCLASS

static final String EXTRACT_SUPERCLASS
Refactoring id of the 'Extract Superclass' refactoring (value: `org.eclipse.jdt.ui.extract.superclass`).

Clients may safely cast the obtained refactoring descriptor to `ExtractSuperclassDescriptor`.

See Also:
  - Constant Field Values

### GENERALIZE_TYPE

static final String GENERALIZE_TYPE
Refactoring id of the 'Generalize Declared Type' refactoring (value: `org.eclipse.jdt.ui.change.type`).

Clients may safely cast the obtained refactoring descriptor to `GeneralizeTypeDescriptor`.

See Also:
  - Constant Field Values

### INFER_TYPE_ARGUMENTS

static final String INFER_TYPE_ARGUMENTS
Refactoring id of the 'Infer Type Arguments' refactoring (value: `org.eclipse.jdt.ui.infer.typearguments`).

Clients may safely cast the obtained refactoring descriptor to `InferTypeArgumentsDescriptor`.

See Also:
  - Constant Field Values

### INLINE_CONSTANT

static final String INLINE_CONSTANT
Refactoring id of the 'Inline Constant' refactoring (value: `org.eclipse.jdt.ui.inline.constant`).

Clients may safely cast the obtained refactoring descriptor to `InlineConstantDescriptor`.

See Also:
  - Constant Field Values

### INLINE_LOCAL_VARIABLE

static final String INLINE_LOCAL_VARIABLE
Refactoring id of the 'Inline Local Variable' refactoring (value: `org.eclipse.jdt.ui.inline.temp`).

Clients may safely cast the obtained refactoring descriptor to `InlineLocalVariableDescriptor`.

See Also:
  - Constant Field Values

### INLINE_METHOD

static final String INLINE_METHOD
Refactoring id of the 'Inline Method' refactoring (value: `org.eclipse.jdt.ui.inline.method`).

Clients may safely cast the obtained refactoring descriptor to `InlineMethodDescriptor`.

See Also:
  - Constant Field Values

### INTRODUCE_FACTORY

static final String INTRODUCE_FACTORY
Refactoring id of the 'Introduce Factory' refactoring (value: `org.eclipse.jdt.ui.introduce.factory`).

Clients may safely cast the obtained refactoring descriptor to `IntroduceFactoryDescriptor`.

See Also:
  - Constant Field Values

### INTRODUCE_INDIRECTION

static final String INTRODUCE_INDIRECTION
Refactoring id of the 'Introduce Indirection' refactoring (value: `org.eclipse.jdt.ui.introduce.indirection`).

Clients may safely cast the obtained refactoring descriptor to `IntroduceIndirectionDescriptor`.

See Also:
  - Constant Field Values

### INTRODUCE_PARAMETER

static final String INTRODUCE_PARAMETER
Refactoring id of the 'Introduce Parameter' refactoring (value: `org.eclipse.jdt.ui.introduce.parameter`).

Clients may safely cast the obtained refactoring descriptor to `IntroduceParameterDescriptor`.

See Also:
  - Constant Field Values

### INTRODUCE_PARAMETER_OBJECT

static final String INTRODUCE_PARAMETER_OBJECT
Refactoring id of the 'Introduce Parameter Object' refactoring (value: `org.eclipse.jdt.ui.introduce.parameter.object`).

Clients may safely cast the obtained refactoring descriptor to `IntroduceParameterObjectDescriptor`.

Since:
  1.2
See Also:
  - Constant Field Values

### MOVE

static final String MOVE
Refactoring id of the 'Move' refactoring (value: `org.eclipse.jdt.ui.move`).

Clients may safely cast the obtained refactoring descriptor to `MoveDescriptor`.

See Also:
  - Constant Field Values

### MOVE_METHOD

static final String MOVE_METHOD
Refactoring id of the 'Move Method' refactoring (value: `org.eclipse.jdt.ui.move.method`).

Clients may safely cast the obtained refactoring descriptor to `MoveMethodDescriptor`.

See Also:
  - Constant Field Values

### MOVE_STATIC_MEMBERS

static final String MOVE_STATIC_MEMBERS
Refactoring id of the 'Move Static Members' refactoring (value: `org.eclipse.jdt.ui.move.static`).

Clients may safely cast the obtained refactoring descriptor to `MoveStaticMembersDescriptor`.

See Also:
  - Constant Field Values

### PULL_UP

static final String PULL_UP
Refactoring id of the 'Pull Up' refactoring (value: `org.eclipse.jdt.ui.pull.up`).

Clients may safely cast the obtained refactoring descriptor to `PullUpDescriptor`.

See Also:
  - Constant Field Values

### PUSH_DOWN

static final String PUSH_DOWN
Refactoring id of the 'Push Down' refactoring (value: `org.eclipse.jdt.ui.push.down`).

Clients may safely cast the obtained refactoring descriptor to `PushDownDescriptor`.

See Also:
  - Constant Field Values

### RENAME_COMPILATION_UNIT

static final String RENAME_COMPILATION_UNIT
Refactoring id of the 'Rename Compilation Unit' refactoring (value: `org.eclipse.jdt.ui.rename.compilationunit`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_ENUM_CONSTANT

static final String RENAME_ENUM_CONSTANT
Refactoring id of the 'Rename Enum Constant' refactoring (value: `org.eclipse.jdt.ui.rename.enum.constant`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_FIELD

static final String RENAME_FIELD
Refactoring id of the 'Rename Field' refactoring (value: `org.eclipse.jdt.ui.rename.field`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_MODULE

static final String RENAME_MODULE
Refactoring id of the 'Rename Module' refactoring (value: `org.eclipse.jdt.ui.rename.module`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

Since:
  1.15
See Also:
  - Constant Field Values

### RENAME_JAVA_PROJECT

static final String RENAME_JAVA_PROJECT
Refactoring id of the 'Rename Java Project' refactoring (value: `org.eclipse.jdt.ui.rename.java.project`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_LOCAL_VARIABLE

static final String RENAME_LOCAL_VARIABLE
Refactoring id of the 'Rename Local Variable' refactoring (value: `org.eclipse.jdt.ui.rename.local.variable`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_METHOD

static final String RENAME_METHOD
Refactoring id of the 'Rename Method' refactoring (value: `org.eclipse.jdt.ui.rename.method`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_PACKAGE

static final String RENAME_PACKAGE
Refactoring id of the 'Rename Package' refactoring (value: `org.eclipse.jdt.ui.rename.package`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_RESOURCE

@Deprecated static final String RENAME_RESOURCE
Deprecated.
Since 1.2. Use `RenameResourceDescriptor.ID` instead.
Refactoring id of the 'Rename Resource' refactoring (value: `org.eclipse.jdt.ui.rename.resource`).

Clients may safely cast the obtained refactoring descriptor to `RenameResourceDescriptor`.

See Also:
  - Constant Field Values

### RENAME_SOURCE_FOLDER

static final String RENAME_SOURCE_FOLDER
Refactoring id of the 'Rename Source Folder' refactoring (value: `org.eclipse.jdt.ui.rename.source.folder`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_TYPE

static final String RENAME_TYPE
Refactoring id of the 'Rename Type' refactoring (value: `org.eclipse.jdt.ui.rename.type`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### RENAME_TYPE_PARAMETER

static final String RENAME_TYPE_PARAMETER
Refactoring id of the 'Rename Type Parameter' refactoring (value: `org.eclipse.jdt.ui.rename.type.parameter`).

Clients may safely cast the obtained refactoring descriptor to `RenameJavaElementDescriptor`.

See Also:
  - Constant Field Values

### USE_SUPER_TYPE

static final String USE_SUPER_TYPE
Refactoring id of the 'Use Supertype Where Possible' refactoring (value: `org.eclipse.jdt.ui.use.supertype`).

Clients may safely cast the obtained refactoring descriptor to `UseSupertypeDescriptor`.

See Also:
  - Constant Field Values